'circuit_chung a program by NGUYEN.Chung (freeware 2013)
#Include Once "windows.bi"
#Include Once "gui_chung.bi"
#Include Once "gl_chung.bi"
#include Once "win/mmsystem.bi"
#Include Once "sounds.bi"

#Inclib "./load3ds_chung"
Declare Function load3DS Cdecl Alias "load3DS" (Byval ficload As ZString Ptr,ByVal textlist As ZString Ptr,_ 
         Byval defauttext As ZString Ptr) As Integer        
'call with autoresize desired size=integer 
Declare Function load3DSsize Cdecl Alias "load3DSsize" (Byval ficload As ZString Ptr,ByVal textlist As ZString Ptr,_ 
         Byval defauttext As ZString Ptr, ByVal size As uint) As Integer        

Sub notice(ByRef msg As string,ByRef title As String ="notice")
	messagebox(0,msg,title,0)
End Sub
Sub confirm(ByRef msg As string,ByRef title As string,ByRef resp As String)
	Dim i As Integer
	i=messagebox(0,msg,title,1)
	If i=1 Then resp="yes" Else resp="no"
End Sub

Dim Shared As Integer itime,quit=0,restart=0,i,j,k,iedit=1,xmax,ymax,imap
Dim Shared As Integer ishadow=0,ntree=100,ntree2=100,nroad2
Dim Shared As ZString * 256 objfile,objfile0
Dim Shared As Integer file
Dim Shared As String curdir0,ficini,ficin,resp
curdir0=CurDir
Dim Shared As Single x,y,z,o1,mx,my,mz,xx,yy,zz,oo1,v
Dim Shared As Integer testficin=0,iview

Sub subquit
	quit=1
End Sub
Dim Shared As Double time0,time1,time2,time3,kfps=1,kfps2,kfps3,dtime2
Dim Shared As Double fps,maxfps=60,tfps,tdrawvie,dtimehour
Dim Shared As Single auxvar,auxvar2,auxvar3
Dim Shared As Single degtorad=ASin(1)/90,radtodeg=90/ASin(1)
Sub setfps()
           	time3=time2
           	time2=Timer
           	time0=time1
           	time1=time2*1000
           	dtime2=1.0/max(10.0,min(200.0,maxfps))-0.0015
           	'If time2<(time3+25) Then Sleep (time3+30-time2)'20'30
           	If time2<(time3+dtime2) Then
           		If time2<time3 Then time2=time3 'if midnight
           		Sleep Int((time3+dtime2+0.001-time2)*1000)'20'30
           	   time2=time3+dtime2+0.001
           	EndIf
           	tfps=0.85*tfps+0.15*min(1.0,(time2-time3))
           	fps=1.0/max(0.001,tfps)	
           	kfps=min(10.0,30/fps)
           	kfps2=min(2.5,25/fps)
           	kfps3=kfps/2
           	
End Sub
Declare Sub initgl
Declare Sub initobjects
Declare Sub inittrees
Declare Sub drawroads
Declare Sub display
Declare Function diro1(dx As Single,dy As Single)As Single 
Declare Sub subhelp
Declare Sub subcustom
Declare Sub initterrain
Declare Sub drawterrain
Declare Sub drawshadow
Declare Sub drawboussole
Declare Sub drawradar
Declare Sub drawvolant
Declare Function getterrainheight(ByVal x As Single,ByVal y As Single) As Single
Declare Function getterrainheight2(ByVal x As Single,ByVal y As Single) As Single
Declare Function getterrainheight3(ByVal x As Single,ByVal y As Single) As Single
Declare Function testroad(ByVal x As Single,ByVal y As Single) As Integer 
Declare Function testroadh(ByVal x As Single,ByVal y As Single) As Single
Declare Function testcollide(wdx As Single,wdy As Single,wdz As Single) As Integer 

Dim Shared As Single o2,o3,mo1,x0=200,y0,z0,vie0=100
Dim Shared As Single caissex=800,caissey,caissez,o1sky
Dim Shared As Single housex=800.3800,housey=800,housez,housedx,housedy
Dim Shared As Single doorx,doory,doordx,doordy
Dim Shared As Single treex(ntree),treey(ntree),treez(ntree),o1tree
Dim Shared As Integer treetype(ntree)
Dim Shared As Double timetree,twin

Dim Shared As Integer tshift,tspace,t1,t2,t3,t4,t5,t6,t7
dim shared as integer tforward,trear
Dim Shared As Single yh=70,vie
Dim Shared As Single cos1=1,sin1,cos2=1,sin2,cos3=1,sin3,co1,si1,co2,si2
Dim Shared As Single cos10,sin10
#Include "joystick.bi"
#Include "movecar.bi"

ficini="circuit_chung.ini"
file=FreeFile
Open ficini For Input As #file
imap=2
If Not Eof(file) Then Line Input #file,ficin:imap=Val(ficin)
ishadow=0
If Not Eof(file) Then Line Input #file,ficin:ishadow=Val(ficin)
ntree2=50
If Not Eof(file) Then Line Input #file,ficin:ntree2=Val(ficin)
x=0:y=0:z=0:o1=0
If Not Eof(file) Then Line Input #file,ficin:x=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:y=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:z=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:o1=Val(ficin)
mx=0:my=0:mz=0
If Not Eof(file) Then Line Input #file,ficin:mx=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:my=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:mz=Val(ficin)
custom=0
If Not Eof(file) Then Line Input #file,ficin:custom=Val(ficin)
mykprop=1
If Not Eof(file) Then Line Input #file,ficin:mykprop=Val(ficin)
mykqueue=1
If Not Eof(file) Then Line Input #file,ficin:mykqueue=Val(ficin)
mykroll=1
If Not Eof(file) Then Line Input #file,ficin:mykroll=Val(ficin)
mykpitch=1
If Not Eof(file) Then Line Input #file,ficin:mykpitch=Val(ficin)
myrv=1
If Not Eof(file) Then Line Input #file,ficin:myrv=Val(ficin)
myrqueue=1
If Not Eof(file) Then Line Input #file,ficin:myrqueue=Val(ficin)
myrroll=1
If Not Eof(file) Then Line Input #file,ficin:myrroll=Val(ficin)
myrpitch=1
If Not Eof(file) Then Line Input #file,ficin:myrpitch=Val(ficin)
mypoids=1
If Not Eof(file) Then Line Input #file,ficin:mypoids=Val(ficin)
myvcruise=1
If Not Eof(file) Then Line Input #file,ficin:myvcruise=Val(ficin)
maxfps=40
If Not Eof(file) Then Line Input #file,ficin:maxfps=Val(ficin)
mykbrakes=1
If Not Eof(file) Then Line Input #file,ficin:mykbrakes=Val(ficin)
myksuspension=1
If Not Eof(file) Then Line Input #file,ficin:myksuspension=Val(ficin)
mykspeed=1
If Not Eof(file) Then Line Input #file,ficin:mykspeed=Val(ficin)
mykpneu=1
If Not Eof(file) Then Line Input #file,ficin:mykpneu=Val(ficin)
Close #file

Sub subrestart
Dim As Integer i
x=0:o1=0
	quit=1
	restart=1
End Sub
Sub save(fic As String)
file=freefile
Open fic For Output As #file
Close #file	
End Sub
Sub load(fic As String)
file=FreeFile
Open fic For Input As #file
Close #file
End Sub
Sub subsave
Dim As String fic,dir0,resp
Dim As Integer ret 
dir0=CurDir  
ChDir(ExePath+"\save\")  
fic=filedialog("save anim","*.anim3d")
fic=Trim(fic)
ChDir(dir0)
If InStr(fic,".")=0 And fic<>"" Then fic=fic+".anim3d"
If Right(LCase(fic),7)=".anim3d" Then 
	confirm("save in "+fic+" ?","confirm",resp)
	If resp="yes" Then
		save(fic)
	EndIf
EndIf
ret=ChDir(dir0)
End Sub
Sub subload
Dim As String fic,dir0
Dim As Integer ret 
dir0=CurDir
ChDir(ExePath+"\save\")  
fic=filedialog("load anim","*.anim3d")
fic=Trim(fic)
ret=ChDir(dir0)
If Right(LCase(fic),7)=".anim3d" Then 
	If FileExists(fic) Then
		load(fic)
	EndIf
EndIf
ret=ChDir(dir0)
End Sub
Sub submap()
Dim As Integer i
getcomboindex("win.map",i)
If i>0 Then imap=i:initterrain()
guisetfocus("win.graph")
End Sub
Sub subshadow()
Dim As Integer i
getcomboindex("win.shadow",i)
If i>0 Then ishadow=i-1
guisetfocus("win.graph")
End Sub
Dim Shared As String msg
Sub subresp
resp=guigettext("winprompt.resp")
End Sub
Sub prompt(ByRef msg As String,ByRef resp0 As String)
statictext("winprompt.msg","msg",10,10,400,40)
edittext("winprompt.resp","",@subresp,10,60,400,20)
openwindow("winprompt","circuit_chung",50,50,450,180)
printgui("winprompt.msg",msg)
printgui("winprompt.resp",resp0)
guisetfocus("winprompt.resp")
While guitestkey(vk_escape)=0 And guitestkey(vk_return)=0
	guiwait
	Sleep 100
Wend
guiscan
resp=guigettext("winprompt.resp")
guiclosewindow("winprompt")
End Sub
Sub subntrees()
Dim As Integer i
	resp=Str(ntree2)
	msg="number of trees : enter a number (5.."+Str(ntree)+")  last="+Str(ntree2)
	prompt(msg,resp)
	If resp<>"" Then
		i=Val(resp)
   	i=max2(5,min2(ntree,i))
	   ntree2=i
	   inittrees()
	EndIf 
End Sub 	
'
' Program start
guibackgroundcolor(0,240,240)
Dim Shared As Integer wx,wy,depth,winx,winy
ScreenInfo wx,wy,depth
'wx=1600:wy=1200
debut:
quit=0
Dim Shared As uint textures(200),ntextures(200)
Dim Shared As String texturesfic(200)
Dim Shared As uint lists(800),nlists(800)
Dim Shared As String listsfic(800)
For i=1 To 200
	texturesfic(i)=""
	textures(i)=0
Next
For i=1 To 800
	listsfic(i)=""
	lists(i)=0
Next

guibackgroundcolor(150,255,150)
xmax=wx-17:ymax=wy-45-70+30
button("win.help","help",@subhelp,10,5,40,24)
button("win.restart","restart",@subrestart,257,5,70,24)
combobox("win.map",@submap,342,5,70,400)
combobox("win.shadow",@subshadow,422,5,90,400)
graphicbox("win.graph",2,40-30,xmax,ymax,"opengl")
	
winx=2:winy=2
openwindow("win","circuit_chung",winx,winy,wx-5,wy-45)

trapclose("win",@subquit)

For i=1 To 50
	addcombo("win.map","map"+Str(i))
Next
selectcomboindex("win.map",imap)

addcombo("win.shadow","noshadow")
addcombo("win.shadow","shadows")
selectcomboindex("win.shadow",ishadow+1)

guistartOpenGL("win.graph")
initgl
initobjects
initterrain
inittrees()


icar=4:subchangecar()

Randomize 
While quit=0 And Not guitestKey(vk_escape) 
	itime+=1:If itime>10000 Then itime=0
	display
	guirefreshopenGL
	guiscan  'scan for input and continue
	If quit=1 Then Exit While

mx0=mx:my0=my:mz0=mz
testo123()
cos1=Cos(o1*degtorad):sin1=sin(o1*degtorad)
cos2=Cos(o2*degtorad):sin2=sin(o2*degtorad)
cos3=Cos(o3*degtorad):sin3=sin(o3*degtorad)
dmx=cos1*cos2:dmy=sin1*cos2:dmz=sin2

	subjoystick()
	If guitestkey(vk_p) Then notice("pause","circuit_chung")
	If guitestkey(vk_f1) Then subhelp()
   If guitestkey(vk_f3) Then 
   	confirm("change time of day ?","confirm",resp)
   	If resp="yes" Then dtimehour=(dtimehour+4)Mod 24
   	guisetfocus("win.graph")
   EndIf
   If guitestkey(vk_f4) Then subcustom()
   If guitestkey(vk_r) And guitestkey(vk_control) Then
   	confirm("reset ?","confirm",resp)
   	If resp="yes" then mx=0:my=0
   EndIf
   keyplane()
   'carb=10000
   movecar
   setspeed
   setvol
   dirv=(mx-mx0)*cos1+(my-my0)*sin1
   testmz
   If testcollide(mx,my,mz) Then testcrash
	/'If guitestkey(vk_1) Then o2+=kfps*2
	If guitestkey(vk_2) Then o2-=kfps*2
	If guitestkey(vk_left) Then o1+=kfps*2
	If guitestkey(vk_right) Then o1-=kfps*2
	If guitestkey(vk_up) Or tforward>0 Then mx+=8*kfps*cos1:my+=8*kfps*sin1'o2+=kfps*1.5
	If guitestkey(vk_down) Or trear>0 Then mx-=4*kfps*cos1:my-=4*kfps*sin1'o2-=kfps*1.5
	If guitestkey(vk_prior) Or b(1) Then v=min(500.0,v+kfps)
	If guitestkey(vk_next) Or b(2) Then v=max(0.0,v-2*kfps)
	If Abs(v)>0.01 Then mx+=v*0.1*kfps*cos1:my+=v*0.1*kfps*sin1
	'/
	'Sleep 20  
	setfps()
Wend
guicloseOpenGL
guiclose'("msg")

If restart=1 Then
	restart=0:itime=0
	'notice("restart")
	guibackgroundcolor(Rnd*255,Rnd*255,Rnd*255)
	guireset:GoTo debut
EndIf

closesounds()

file=freefile
Open ficini For Output As #file
Print #file,imap
Print #file,ishadow
Print #file,ntree2
Print #file,x
Print #file,y
Print #file,z
Print #file,o1
Print #file,mx
Print #file,my
Print #file,mz
Print #file,custom
Print #file,mykprop
Print #file,mykqueue
Print #file,mykroll
Print #file,mykpitch
Print #file,myrv
Print #file,myrqueue
Print #file,myrroll
Print #file,myrpitch
Print #file,mypoids
Print #file,myvcruise
Print #file,maxfps
Print #file,mykbrakes
Print #file,myksuspension
Print #file,mykspeed
Print #file,mykpneu
Close #file

guiquit
End

Dim Shared As uint grasstexture,bloodtexture,objtexture,objtexture0,firetexture
Dim Shared As uint grasstexture0
Dim Shared As uint caisselist,caissetexture,skydometexture,treelist
Dim Shared As uint treetexture,treetexture2,treetexture3,suntexture,volanttext
Dim Shared As uint housetexture,houselist,roadtext,roadcrosstext,parktext
Const As Integer nroad=8200
Dim Shared As Integer kroad,roadtype(nroad)
Dim Shared As uint roadtexture(nroad)
Dim Shared As Single roadx(nroad),roady(nroad),roadz(nroad),roado1(nroad)
Dim Shared As Single roadh=40,roaddx(nroad),roaddy(nroad),roaddz(nroad)
Dim Shared As Single roadtx(nroad),roaddtx(nroad),roadco1(nroad),roadsi1(nroad)
Dim Shared As Single scalex=900,scalez=20
Dim Shared As Single terrain(-100 To 612,-100 To 612)
Dim Shared As Integer terrainroad(-100 To 612,-100 To 612)
Sub initgl
        /' init OpenGL '/        
	glMatrixMode GL_PROJECTION
	glLoadIdentity
	'              anglevue    xmax/ymax   mxmin,mxmax
	'gluPerspective   48.0,    640.0/480.0,  2.0, 13000.0
	'gldistmax=13000*10
	'gluPerspective   48.0,    xmax/ymax,  2.0, gldistmax*25
	gluPerspective   48.0,    xmax/ymax,  5.3, 100000'1700000
	'gluPerspective   89.0,    xmax/ymax,  3.3, 100000'1700000
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	
	glShadeModel GL_SMOOTH
	glClearColor 0.50, 0.50, 1.0, 0.0
	glClearDepth 1.0
	glEnable GL_DEPTH_TEST
	glDepthFunc GL_LEQUAL
	
	'gldisable gl_cull_face
	glenable gl_lighting
	glenable gl_light0
	glenable gl_normalize
	'glnormals=1
   glEnable GL_COLOR_MATERIAL
   glColorMaterial GL_FRONT_and_back,GL_DIFFUSE

	glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST    '' Really Nice Perspective Calculations
	'glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST    '' Really Nice Perspective Calculations
		
	Dim LightAmbient(0 to 3) as single => {0.625, 0.625, 0.625, 1.0}   '' Ambient Light Values
	Dim LightAmbient2(0 to 3) as single => {0.7,0.7,0.7, 1.0}   '' Ambient Light Values
	Dim LightAmbient3(0 to 3) as single => {0.1,0.1,0.1, 1.0}   '' Ambient Light Values
	Dim LightDiffuse(0 to 3) as single => {1.0, 1.0, 1.0, 1.0}   '' Diffuse Light Values
	Dim LightPosition(0 to 3) as single => {0.0, 0.0, 2000.0, 1.0}  '' Light Position
   gllightfv(gl_light0,GL_ambient,glparam4f(1,1,1,0)) 'GL_AMBIENT GL_DIFFUSE GL_SPECULAR GL_POSITION
	glLightfv GL_LIGHT1, GL_AMBIENT, @LightAmbient(0)   '' Setup The Ambient Light
	glLightfv GL_LIGHT2, GL_AMBIENT, @LightAmbient2(0)   '' Setup The Ambient Light
	glLightfv GL_LIGHT3, GL_AMBIENT, @LightAmbient3(0)   '' Setup The Ambient Light
	'glLightfv GL_LIGHT0, GL_DIFFUSE, @LightDiffuse(0)   '' Setup The Diffuse Light
	'glLightfv GL_LIGHT0, GL_POSITION, @LightPosition(0) '' Position The Light
	'glEnable GL_LIGHT0                                  '' Enable Light One
 
End Sub
Function loadlist0(fic As String,size As Single=150) As UInteger 
Dim As Integer myobjlist
Dim As ZString*256 objfic
objfic=fic
myobjlist=glgenlists(1)
glnewlist myobjlist,GL_COMPILE 'GL_COMPILE_AND_EXECUTE'4865
If FileExists(objfic) Then
  'load3DS(@objfic,@"",@"")
  load3DSsize(@objfic,@"",@"",size)'150)
EndIf
glendlist	
Return myobjlist
End Function 
Dim Shared As gldouble modelview(16),projection(16)
Dim Shared As gldouble modelview0(16),modelview1(16)
Dim Shared As Integer tdraw,tshadow
Sub myglcalllist(gllist As uint)
If tdraw=1 Then
	If tshadow=1 Then
		glcolor3f(0,0.26,0)
	EndIf
	glcalllist(gllist)
EndIf
End Sub
Sub myglbindtexture(gltexture2d As glint,texture As gluint)
	If tdraw=0 then exit sub 
	If tshadow=0 Or texture=treetexture Or texture=treetexture2 Or _
		texture=treetexture3 Then
		glbindtexture(gltexture2d,texture)
	Else 
		glbindtexture(gl_texture_2d,grasstexture0)
	EndIf
End Sub
Function guiloadtexture2(ByRef filename As String,ByVal maxcolor As uint=255, ByVal alph As uint=127) As uint 
Dim As Integer i,j=0
Dim As String fic 
fic=LCase(Trim(filename))
If FileExists(fic)=0 Then Return 0
For i=1 To 200
	If texturesfic(i)=fic Then
		ntextures(i)+=1
		Return textures(i)
	EndIf
	If texturesfic(i)="" And j=0 Then j=i
Next
If j=0 Then Return 0
ntextures(j)=1
texturesfic(j)=fic
textures(j)=guiloadtexture(fic,maxcolor,alph)
Return textures(j) 
End Function
Sub guideletetexture2(itexture As uint)
Dim As Integer i
If itexture=0 Then Exit Sub 
For i=1 To 200
	If textures(i)=itexture Then
		If ntextures(i)>0 Then ntextures(i)-=1
		If ntextures(i)<=0 Then
			guideletetexture(itexture)
			texturesfic(i)=""
			textures(i)=0
			Exit For 
		EndIf
	EndIf
Next
End Sub
Sub guideletelist2(ilist As uint)
Dim As Integer i
If ilist=0 Then Exit Sub 
For i=1 To 200
	If lists(i)=ilist Then
		If nlists(i)>0 Then nlists(i)-=1
		If nlists(i)<=0 Then
			gldeletelists(ilist,1)
			listsfic(i)=""
			lists(i)=0
			Exit For 
		EndIf
	EndIf
Next
End Sub
Function loadlist(ByRef filename As String,ByVal size As Single=150) As uint 
Dim As Integer i,j=0
Dim As String fic 
fic=LCase(Trim(filename))
If FileExists(fic)=0 Then Return 0
For i=1 To 800
	If listsfic(i)=fic Then
		nlists(i)+=1
		Return lists(i)
	EndIf
	If listsfic(i)="" And j=0 Then j=i
Next
If j=0 Then Return 0
nlists(j)=1
listsfic(j)=fic
lists(j)=loadlist0(fic,size)
Return lists(j) 
End Function 
Sub inittrees()
Dim As Integer i,j
Randomize(imap)'1)
ntree2=min2(ntree,ntree2)
For i= 1 To ntree2
   Var do1=3*360*(i+Rnd)/ntree2
   Var aux=3000*(1+Rnd)
   treex(i)=aux*Cos(do1*degtorad):treey(i)=aux*Sin(do1*degtorad)
  	For j=1 To 30
   		If Abs(testroadh(treex(i),treey(i)))<1e-7 Then Exit For
     		treex(i)+=sgn(mx-treex(i))*500+Rnd*1000
     		treey(i)+=Sgn(my-treey(i))*500+Rnd*1000 
  	Next
   treez(i)=getterrainheight(treex(i),treey(i))
   treetype(i)=Int(Rnd*2.99)
Next i
Randomize	
End Sub
Sub initobjects
Dim As Integer i,j,k,l,ii,jj,kk
Dim As Single x,y,z
grasstexture=guiloadtexture2(curdir0+"/media/grass.jpg")
grasstexture0=guiloadtexture2("media/grass.jpg")
caissetexture=guiloadtexture2(curdir0+"/objects/caisse.jpg")
housetexture=guiloadtexture2(curdir0+"/objects/house3.jpg")
skydometexture=guiloadtexture2("media/skydome1.jpg")
treetexture=guiloadtexture2("media/arbre.jpg",240)
treetexture2=guiloadtexture2("media/arbre2.jpg",240)
treetexture3=guiloadtexture2("media/arbre3.jpg",240)
suntexture=guiloadtexture2("media/sun.jpg")'20,175)
caisselist=loadlist(curdir0+"/objects/caisse.3ds",59)
houselist=loadlist(curdir0+"/objects/house3.3ds",800)

roadtext=guiloadtexture2("media/road.bmp") 
roadcrosstext=guiloadtexture2("media/roadcross.bmp") 
parktext=guiloadtexture2("media/parking4.bmp") 
volanttext=guiloadtexture2("media/volant.jpg",250) 

For j=1 To 30
		If testroad(housex,housey)=0 Then Exit For
  		housex+=sgn(mx-housex)*500+(Rnd)*2000
  		housey+=Sgn(my-housey)*500+(Rnd)*2000 
Next
Var sc=330/680.0
housedx=680*sc:housedy=430*sc
doorx=housex-680*sc:doory=housey
doordx=90*sc:doordy=70*sc
      	housez=getterrainheight(housex,housey)	
         For i=-1 To 1
	        For j=-1 To 1
		         housez=min(housez,getterrainheight(housex+i*housedx,housey+j*housedy))
	        Next
         Next
twin=Timer 

End Sub
Dim Shared As Single cursorx,cursory,cursorz 
Sub glplacecursor(ByVal x As Single,ByVal y As Single,ByVal z As Single=-40)
   glLoadIdentity()
   cursorx=(-0.31+23.7*(-1+2*x/xmax)*(xmax/ymax)*(520/700))
   cursory=-0.25+17.1*(1-2*y/ymax)
   cursorz=z
   glTranslatef (cursorx,cursory,cursorz)
End Sub 
Sub drawmort
Dim As Integer i
 gldisable GL_DEPTH_TEST
 gldisable gl_lighting 
 glEnable GL_BLEND
 glBlendFunc GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
 glcolor4f(1,0.7,0,0.35)
 glpushmatrix
 glplacecursor(xmax/2,ymax/2)
 glcarre(50*xmax/1000)
 glpopmatrix
 glcolor4f(1,1,1,1)
 gldisable GL_BLEND
 glenable GL_DEPTH_TEST
 If vie<0.999 Then
 	'soundaah
 	'soundboom
 	guirefreshopenGL()
 	Sleep  5000
   vie=vie0
 	confirm "you are dead !","confirm",resp
   Sleep 500
 EndIf
End Sub
Sub gldrawtext(ByRef text As String,ByVal x As Single,ByVal y As Single,ByVal scale As Single=1.0)
   glLoadIdentity()
   gldisable(gl_texture_2d)
   'glTranslatef (22*(-1+2*x/xmax)*(xmax/ymax)*(520/700),17*(1-2*y/ymax),-38)
   glTranslatef ((-0.31+23.7*(-1+2*x/xmax)*(xmax/ymax)*(520/700)),-0.25+17.1*(1-2*y/ymax),-40)
   glscalef(scale,scale,scale)
   guigltext(text)
   glenable(gl_texture_2d)
End Sub
Sub mulmatrix(mat As gldouble ptr,x As Single,y As Single,z As Single, _  
	                               x1 As Single,y1 As Single,z1 As Single)
Dim As Single xx,yy,zz
xx=mat[0]*x+mat[1]*y+mat[2]*z+mat[3]
yy=mat[4]*x+mat[5]*y+mat[6]*z+mat[7]
zz=mat[8]*x+mat[9]*y+mat[10]*z+mat[11]
x1=xx:y1=yy:z1=zz
End Sub 
sub mulmatrixinv(mat As gldouble ptr,x As Single,y As Single,z As Single, _  
	                               x1 As Single,y1 As Single,z1 As Single)
Dim As Single xx,yy,zz
xx=mat[0]*x+mat[4]*y+mat[8]*z-mat[3]
yy=mat[1]*x+mat[5]*y+mat[9]*z-mat[7]
zz=mat[2]*x+mat[6]*y+mat[10]*z-mat[11]
x1=xx:y1=yy:z1=zz
End Sub 
Sub test_()
glGetdoublev(GL_MODELVIEW_MATRIX, @modelview(0))
Dim As gldouble modelviewinv(16)=_ 
             {modelview(0),modelview(4),modelview(8), -modelview(3),_ 
              modelview(1),modelview(5),modelview(9), -modelview(7),_ 
              modelview(2),modelview(6),modelview(10), -modelview(11),_
              -modelview(12),-modelview(13),-modelview(14), modelview(15)}
glMatrixMode GL_PROJECTION
glLoadIdentity
'              anglevue    xmax/ymax   mxmin,mxmax
gluPerspective   1.0,    xmax/ymax,  5.3, 100000
glGetdoublev(GL_PROJECTION_MATRIX, @projection(0))
glMatrixMode GL_PROJECTION
glloadmatrixd(@projection(0))
glMatrixMode GL_MODELVIEW
'glGetfloatv(GL_PROJECTION_MATRIX, @projection(0))
'glloadmatrixf(@projection(0))
Dim As GLint viewport(4)
glGetIntegerv( GL_VIEWPORT, @viewport(0) )
Dim As Single winx,winy,winz
glReadPixels(winX,viewport(3)-winY, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, @winZ)
Dim As gldouble posX, posY, posZ
'gluUnProject(winX,winY,winZ,@modelview(0),@projection(0),@viewport(0),@posX,@posY,@posZ)	
End Sub
Sub test2_()
Dim As Single winx,winy,winz,scale
glgetfloatv(gl_depth_scale,@scale)
glReadPixels(xmax/2,ymax/2, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, @winz)
winz=winz*scale
End Sub
Function isinside(ByVal mx As Single,ByVal my As Single,ByVal housex As Single,ByVal housey As Single,_  
	               ByVal dx As Single,ByVal dy As Single) As Integer 
If Abs(mx-housex)>dx Then Return 0
If Abs(my-housey)>dy Then Return 0
Return 1	    
End Function            
Dim Shared As Single objx,objy,objz
Sub drawtrees()
Dim As Integer i,j
If iedit<=3 Then
      If Timer>timetree Or Timer<(timetree-99) Then
	     timetree=Timer+Rnd*Rnd 
	     o1tree=Rnd/2.4
      EndIf
      glenable gl_alpha_test
      glAlphaFunc(gl_less,10/254)
      If tshadow=0 Then glcolor3f(1,1,1)
 For i= 1 To ntree2
      Select Case treetype(i)
      	Case 0:myglbindtexture(GL_TEXTURE_2D,treetexture)
      	Case 1:myglbindtexture(GL_TEXTURE_2D,treetexture2)
      	Case 2:myglbindtexture(GL_TEXTURE_2D,treetexture3)
      End Select
      Var changetree=0,disttree=10000	
      While treex(i)<mx-disttree :treex(i)+=disttree*2:changetree=1:Wend 
      While treex(i)>mx+disttree :treex(i)-=disttree*2:changetree=1:Wend 	
      While treey(i)<my-disttree :treey(i)+=disttree*2:changetree=1:Wend 
      While treey(i)>my+disttree :treey(i)-=disttree*2:changetree=1:Wend 
      If changetree=1 Then
      	For j=1 To 20
      		If Abs(testroadh(treex(i),treey(i)))<1e-7 Then Exit For
      		treex(i)+=sgn(mx-treex(i))*500+Rnd*1000
      		treey(i)+=Sgn(my-treey(i))*500+rnd*1000 
      	Next
      	treez(i)=getterrainheight(treex(i),treey(i))	
      EndIf
    	glpushmatrix
    	If tshadow=0 Then
    		gltranslatef(treex(i),treey(i),treez(i)-30)
    	Else 
    		gltranslatef(treex(i),treey(i),z-30)
    	EndIf
    	glrotatef(o1tree+(treex(i)+treey(i))/22,0,0,1)
    	Var scz=1+(Abs(treex(i)+treey(i)) Mod 50)/380
    	glscalef(scz,scz,scz)
      Var scale=6
      Var auxy=72*scale,auxz=120*scale
      gltexcarre2 auxy,auxz
      gltexcarre2rot auxy,auxz,60
      gltexcarre2rot auxy,auxz,120 
      glpopmatrix
 Next i 
 gldisable gl_alpha_test
EndIf 
End Sub
Const ScrCopy = &HCC0020
Dim Shared As Single timehour,ksoleil,kxsoleil,kysoleil,kzsoleil,timedo2
Sub drawsunset()
Dim As Single aux,heure  
timehour=Val(Left(Time(),2))+Val(Mid(Time(),4,2))/60+dtimehour
While timehour>24:timehour-=24:Wend
timedo2=max(18.0,min(162.0,180*(12+1.5*(12-timehour))/24))
heure=timehour
  If heure<=4 or heure>=21 Then
  	  ksoleil=0.4
  EndIf 
  If heure>4 And heure<=6 Then
  	  aux=(heure-4)/2
  	  ksoleil=0.74*aux+(1-aux)*0.4
  EndIf     
  If heure>6 And heure<=8 Then
  	  aux=(heure-6)/2
  	  ksoleil=1.0*aux+(1-aux)*0.74
  EndIf
  If heure>8 And heure<=17 Then
  	  ksoleil=1.0
  EndIf
  If heure>17 And heure<=19 Then 
  	  aux=(19-heure)/2
  	  ksoleil=1.0*aux+(1-aux)*0.74 
  EndIf
  If heure>19 And heure<=21 Then 
  	  aux=(21-heure)/2
  	  ksoleil=0.74*aux+(1-aux)*0.4
  EndIf
glClearColor 0.5*ksoleil, 0.5*ksoleil, 1.0*ksoleil, 0.0
kxsoleil=0
kysoleil=Cos(timedo2*degtorad)*25000
kzsoleil=Sin(timedo2*degtorad)*25000	
aux=ksoleil'0.5
glpushmatrix
gltranslatef( x-kxsoleil,y-kysoleil,z+kzsoleil)
glrotatef(90,0,0,1)
glrotatef(timedo2,0,1,0)
glEnable GL_BLEND
glBlendFunc GL_SRC_color,GL_ONE'_MINUS_SRC_color
gldisable GL_LIGHTING
'gldisable GL_DEPTH_TEST
glEnable GL_TEXTURE_2D
glbindtexture(gl_texture_2d,suntexture)
aux=210/256'184/256'170/256
glcolor3f(aux,aux,aux*0.6)
'glcolor3f( aux,aux*ksoleil,aux*ksoleil)
gltexcarre3(2000*10,1800*10)
'gltexsphere(1000)
'glEnable GL_DEPTH_TEST
gldisable gl_blend 
glpopmatrix
End Sub
Sub gldrawhouse()
Dim As Integer i,j
      glEnable GL_TEXTURE_2D 
      myglbindtexture GL_TEXTURE_2D,housetexture 
      Var changehouse=0,disthouse=10000	
      While housex<mx-disthouse :housex+=disthouse*2:changehouse=1:Wend 
      While housex>mx+disthouse :housex-=disthouse*2:changehouse=1:Wend 	
      While housey<my-disthouse :housey+=disthouse*2:changehouse=1:Wend 
      While housey>my+disthouse :housey-=disthouse*2:changehouse=1:Wend 
      If changehouse=1 Then
      	For j=1 To 30
      		If testroad(housex,housey)=0 Then Exit For
      		housex+=sgn(mx-housex)*500+Rnd*2000
      		housey+=Sgn(my-housey)*500+Rnd*2000
      	Next
      	housez=getterrainheight(housex,housey)	
         For i=-1 To 1
	        For j=-1 To 1
		         housez=min(housez,getterrainheight(housex+i*housedx,housey+j*housedy))
	        Next
         Next
         Var sc=330/680
         doorx=housex-680*sc:doory=housey
      EndIf
 		glpushmatrix
		glTranslatef housex,housey,housez
		'glRotatef o1-90, 0, 0, 1
		'glRotatef o2, -1, 0, 0
		'glRotatef o3, 0, 1, 0 
      If tshadow=0 Then glColor3f 1.0, 1.0, 1.0
		myglcalllist houselist
		glpopmatrix	
End Sub
Sub drawcaisse()
      glEnable GL_TEXTURE_2D 
      myglbindtexture GL_TEXTURE_2D,caissetexture 
      Var changecaisse=0,distcaisse=10000	
      While caissex<mx-distcaisse :caissex+=distcaisse*2:changecaisse=1:Wend 
      While caissex>mx+distcaisse :caissex-=distcaisse*2:changecaisse=1:Wend 	
      While caissey<my-distcaisse :caissey+=distcaisse*2:changecaisse=1:Wend 
      While caissey>my+distcaisse :caissey-=distcaisse*2:changecaisse=1:Wend 
      If changecaisse=1 Then caissez=getterrainheight(caissex,caissey)	
 		glpushmatrix
		glTranslatef caissex,caissey,caissez
		'glRotatef o1-90, 0, 0, 1
		'glRotatef o2, -1, 0, 0
		'glRotatef o3, 0, 1, 0 
      glColor3f 1.0, 1.0, 1.0
		myglcalllist caisselist
		glpopmatrix	
End Sub
Dim Shared As Single mxx,myy,mzz,dtx,dty,texscale=1
Dim Shared As Integer bmpx=512
Sub display
Dim As Integer i,j
Dim As Single x1,y1,z1

   x=mx:y=my:z=mz
	If ishadow=1 And ((Abs(x-mxx)+Abs(y-myy))>0.001 Or (itime mod 2)=0) Then 
	   glClearColor 1,1,1, 1.0
		glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
      glMatrixMode GL_PROJECTION
      glLoadIdentity
      '              anglevue    xmax/ymax   mxmin,mxmax
      'gluPerspective   1,    xmax/ymax,  100, 1000000
      '        left right bottom top znear zfar
      Dim As Single ksin,kcos,timeh,do2
      Var k=900
      'timeh=timehour'Val(Left(Time,2))+Val(Mid(Time,4,2))/60
      'timedo2=max(18.0,min(162.0,180*(12+1.5*(12-timeh))/24))
      do2=timedo2
      ksin=k*Sin(do2*degtorad):kcos=k*Cos(do2*degtorad)
      glortho(-k,k,-ksin,ksin,10,100000)
      glmatrixmode gl_modelview
      Var dbx=bmpx'512
      glviewport(0,0,dbx,dbx)
      tshadow=1
      glLoadIdentity ()
      If kcos<0 Then glrotatef(180,0,0,1)
      'Var k=0.3'dbx/900'scalex=900:texscale=8000/scalex
     	glulookat(x,y-kcos*100,z+ksin*100, x,y,_   
    	          z, 0,0,1)
    	mxx=x:myy=y:mzz=z
    	'gltranslatef((x-x),(y-y),z)
		glpushmatrix
		'glcolor3f(0,0.7,0)
		'glcolor3f(1,1,1)
		glenable(gl_texture_2d)
		'glbindtexture(gl_texture_2d,grasstexture0)
      texscale=2
      dtx=-0.5-(0.1)/texscale
      dty=-0.5-(0.1)/texscale
		'drawterrain
      'dtx=-0.5-(0.1+mxx/scalex)/texscale
      'dty=-0.5-(0.1+myy/scalex)/texscale
      dtx=-0.5-(mxx/scalex)/texscale
      dty=-0.5-(myy/scalex)/texscale
		glpopmatrix
    	/'glpushmatrix
    	gltranslatef(0,0,z+yh)
    	glcolor3f(0,0,0)
    	glbindtexture(gl_texture_2d,warriortexture)
    	gltexsphere 30
    	glcolor3f(1,1,1)
    	glpopmatrix '/
    	glcolor3f(0,0.3,0)
	   If (isinside(x,y,housex,housey,housedx-40,housedy-40)=0) Then  
    	   drawtrees()
    	   gldrawhouse()
    	   drawcaisse
	   EndIf    
    	'Exit sub
      'glReadPixels(0,0, dbx,dbx, _   
      '             GL_rgba, GL_UNSIGNED_BYTE, bmpbits)'+dbx*dbx\2)
      'bitblt(bmpdc,0,0,bmpx,bmpy,bmp2dc,0,0,srcand)'srcpaint)'srcand)
      glbindtexture(gl_texture_2d,grasstexture)
      'gltexparameteri(gl_texture_2d,GL_GENERATE_MIPMAP,gl_true)
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_linear)
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_linear)'NEAREST)'nomipmap
      'glcopyTexImage2D(GL_TEXTURE_2D, 0, gl_rgba,0,0,bmpx,bmpx, 0)   
      glcopyTexSubImage2D(GL_TEXTURE_2D, 0, 0,0, 0,0,dbx,dbx)   
      'glTexSubImage2D(GL_TEXTURE_2D, 0, 0,0,bmpx,bmpy, GL_rgba, GL_UNSIGNED_BYTE, bmpbits)   
      'gluBuild2DMipmaps(GL_TEXTURE_2D, 4, bmpx,bmpy, GL_BGRA ,GL_UNSIGNED_BYTE ,bmpbits )
      'glTexImage2D(GL_texture_2d,0,4, bmpx,bmpy, 0,gl_bgra,GL_UNSIGNED_BYTE, bmpbits)
      'glTexSubImage2D(GL_TEXTURE_2D, 1, 0,0,bmpx,bmpy, GL_bgra, GL_UNSIGNED_BYTE, bmpbits)   
      'glgeneratemipmap(gl_texture_2d)
	EndIf 
	
      glMatrixMode GL_PROJECTION
      glLoadIdentity
      '              anglevue    xmax/ymax   mxmin,mxmax
      gluPerspective   48,    xmax/ymax,  5.3, 100000
      glmatrixmode gl_modelview
      glviewport(0,0,xmax,ymax)
      tshadow=0 
	
	   glClearColor 0.50, 0.50, 1.0, 0.0
		glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
      'glLoadIdentity ()
    	'glulookat(mx,my,mz+yh, mx+1000*cos1*cos2,my+1000*sin1*cos2,_   
    	'          mz+1000*sin2+yh, -sin3*sin1*0.85,sin3*cos1*0.85,cos3)

tdraw=0  'calculate weaponx1,x2,headx1,shieldx1
      glLoadIdentity ()
     	glulookat(0,0,0, 1000,0,_   
    	          0, -sin3*sin1*0.85,sin3*cos1*0.85,cos3)	   
		/'glpushmatrix
		z=getterrainheight(x,y)
		glTranslatef x,y,z
		glRotatef o1+90, 0, 0, 1
		'glRotatef o2, -1, 0, 0
		glRotatef o3, 0, 1, 0
		glscalef(0.2,0.2,0.2)
      drawpersotest(myperso)
      glpopmatrix
      x1=myperso->headx1
      y1=myperso->heady1
      z1=myperso->headz1
      '/
tdraw=1

If car>=1 And plane>0 And suspension1>0.01 Then 'suspensions  
 vm20=vm2
 vm2=vmx2*cos1+vmy2*sin1
 'o2+=(vm2-vm20)*8*suspension/(0.02+kfps/2)'*5*
 o2+=(vm2-vm20)*5*suspension1/(0.02+kfps/2)'*5*
 do222+=(o2-o222)*0.04*kfps-0.062*do222*kfps*ko222 
 o222+=do222*0.3*kfps
Else
 vm20=vm2
 vm2=vmx2*cos1+vmy2*sin1
 o222=o2
EndIf 
cos222=Cos(o222*degtorad):sin222=Sin(o222*degtorad)
If v>4 Then suspension1=max(0.0,suspension1-0.08*kfps)

    glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT)
    glLoadIdentity ()
    If tourelle=0 Or plane=0 Then
    	If plane>0 Then
    		If car>=1 Then
    			glulookat(mx,my,mz+yh, mx+1000*cos1*cos222,my+1000*sin1*cos222,_   
    			          mz+1000*sin222+yh, -sin3*sin1*0.85,sin3*cos1*0.85,cos3)
    		Else 
    			glulookat(mx,my,mz+yh, mx+1000*dmx,my+1000*dmy,mz+1000*dmz+yh, -sin3*sin1*0.85,sin3*cos1*0.85,cos3)
    		EndIf
    	Else 
    		glulookat(mx,my,mz+yh, mx+1000*dmx,my+1000*dmy,mz+1000*dmz+yh, 0,0,1)
    	EndIf
    Else 
    	to2=max2(-89,min2(89,to2))
    	While to1<-180:to1+=360:Wend
    	While to1>180:to1-=360:wend
    	tcos1=Cos((to1+o1)*degtorad):tsin1=Sin((to1+o1)*degtorad)
    	aux=to2+o2*Cos(to1*degtorad)
    	tcos2=Cos(aux*degtorad):tsin2=Sin(aux*degtorad)
    	tcos3=1.0:tsin3=0.0
      tdx=tcos1*tcos2:tdy=tsin1*tcos2:tdz=tsin2   	
      glulookat(mx,my,mz+yh,mx+tdx*1000,my+tdy*1000,mz+tdz*1000+yh, -tsin3*tsin1,tsin3*tcos1,tcos3)
    EndIf
      /'If iview>=0 Then 
      	yh=mzh'50
      	'While o1>360:o1-=360:Wend
      	'While o1<-360:o1+=360:wend
         'cos1=Cos(o1*degtorad):sin1=Sin(o1*degtorad)
         glLoadIdentity ()
         'mz=getterrainheight3(mx,my)
    		'Var myheado1=0,myheado2=0
    		'co1=Cos((o1+myheado1)*degtorad):si1=Sin((o1+myheado1)*degtorad)
    		'co2=Cos((o2+myheado2-5)*degtorad):si2=Sin((o2+myheado2-5)*degtorad)
     	   'cos1=co1:sin1=si1
     	   co1=cos1:si1=sin1:co2=cos2:si2=sin2
     	   glulookat(mx,my,mz+yh, mx+co1*co2*1000,my+si1*co2*1000,mz+yh+si2*1000,_   
    	             -sin3*si1*0.85,sin3*co1*0.85,cos3)
    	   'mo1=o1+myheado1
    	EndIf '/              		
    	'glgetdoublev(gl_modelview_matrix,@modelview0(0))
     	'mulmatrix(@modelview0(0),x,y,z,x,y,z)
    	'mulmatrixinv(@modelview0(0),x,y,z,x,y,z)
    	
		glenable(gl_texture_2d)
    			
		glpushmatrix
		glenable(gl_texture_2d)
		'If ishadow=1 Then 
		'  glcolor3f(1,1,1)
		'  myglbindtexture(gl_texture_2d,grasstexture)
		'Else
		  glcolor3f(0,0.7,0)
		  myglbindtexture(gl_texture_2d,grasstexture0)
		'EndIf   
		If iedit>=-3 Then
			drawterrain
		Else
		   gltranslatef(0,0,0)
		   gltexdisk(0,7000)
		EndIf    
		glpopmatrix

		If ishadow=1 Then drawshadow
						
      glpushmatrix
      gldisable(gl_lighting)
      myglbindtexture(GL_TEXTURE_2D,skydometexture)
      gltranslatef(0.84*x,0.84*y,0)
      o1sky-=Rnd*0.0159
      glrotatef(o1sky,0,0,1)
      'glcolor3f(1,1,1)
      glcolor3f ksoleil, ksoleil, min(1.0,2.0*ksoleil)
      gltexsphere(49000)
      glpopmatrix

		drawsunset
      
      If volant=1 And tourelle=0 Then drawvolant

      drawtrees()
		  
      drawcaisse()
      
      gldrawhouse()
   	
    	drawroads()
            
      
   	gldisable gl_texture_2d	
      gldisable GL_DEPTH_TEST
      gldisable gl_lighting
		glpushmatrix
		glcolor3f(0,1,0)
		gldrawtext("fps "+Str(Int(fps)),15,25,1.5)
        If (icar=2 Or icar=5) And tourelle=0 Then 
        	glcolor3f(0.3,0.4,1)
        Else 	
        	glcolor3f(0.4,1,0.4)
        EndIf
        If tourelle=1 And plane>=1 Then gldrawtext("tourelle",xmax-70,18,1.2)
        If Abs(auxvar)>0.00001 Then gldrawtext("auxvar= "+Str(auxvar),15,ymax-59,1.2)
        If Abs(auxvar2)>0.00001 Then gldrawtext("auxvar2= "+Str(auxvar2),15,ymax-79,1.2)
        If Abs(auxvar3)>0.00001 Then gldrawtext("auxvar3= "+Str(auxvar3),15,ymax-99,1.2)
        gldrawtext("prop= "+Str(Int(prop0))+"  v= "+Str(Int(v*4.5))+"."+Str(Int(v*45+1000)Mod 10),15,ymax-35,1.2)
        gldrawtext("x= "+Str(Int(mx))+"  y= "+Str(Int(my))+"  z= "+Str(Int(mz)),15,ymax-10,1.2)
        glcolor3f(0,1,1)
		glpopmatrix
		drawboussole:drawradar
      glenable GL_DEPTH_TEST
      
End Sub 
Sub subhelp()
Dim As String msg,cr=Chr(13)
	msg="F1 => help"+cr
   msg+=cr+"escape => quit"
   msg+=cr+"F3 => change time of day"
	'msg+=cr+"X,C => prev/next car,plane"
	msg+=cr+"arrows => direction move"
	msg+=cr+"pageup,1   => accelerate"
	msg+=cr+"pagedown,2 => decelerate"
	msg+=cr+"AZEQDS,num8,num2 => turn left,right"
	'msg+=cr+"Lshift + arrows => look around (car mode)"
	msg+=cr+"space  => carhorn  / ctrl => handbrakes"
	msg+=cr+"ctrl+R  => reset position"
	'msg+=cr+"ctrl+L  => load map"
	'msg+=cr+"ctrl+S  => save map"
	'msg+=cr+"ctrl+F  => fog "
	msg+=cr+"T  => tourelle view"
	msg+=cr+"V  => cockpit wheel on/off"
	msg+=cr+"F4 => custom menu"
	'msg+=cr+"ctrl+ up/down arrow => gear +1/-1"
	'msg+=cr+"ctrl+G  => change gearbox type (manual,auto)"
	'msg+=cr+"ctrl+N  => change cars number"
	'msg+=cr+"ctrl+R  => race cars number"
	'msg+=cr+"ctrl+D  => change max clip distance"
	msg+=cr+"P  => pause"
	'msg+=cr+"F9 => fullscreen (on/off)"
	msg+=cr+cr+"joystick and gamepad supported"
	notice(msg,"help")
	msg="joystick/gamepad"+cr
	msg+=cr+"button1 => accelere"	
	msg+=cr+"button2 => decelere"	
	msg+=cr+"button3 => shoot"	
	msg+=cr+"button4 => tourelle view"	
	msg+=cr+"button5 => carhorn"	
	msg+=cr+"button6 => handbrakes"	
	msg+=cr+"button7 => carhorn"	
	msg+=cr+"button8 => cockpit"
	'msg+=cr+"hatup   => cartype+1"
	'msg+=cr+"hatdown => cartype-1"
	msg+=cr+"left joystick  => direction"
	msg+=cr+"right joystick => look around"
	notice(msg,"help")	
End Sub
Dim Shared As Single terrain0(-100 To 612,-100 To 612)
Dim Shared As Single dxterrain
Dim Shared As vect terraincolor(-100 To 612,-100 To 612),terraincolor0(-100 To 612,-100 To 612)
Sub drawroad1(ByVal iroad As integer)
Dim As Single dx=1000,dy=400,tx=1,dz,x,y,z
Dim As Integer i,j
x=roadx(iroad):y=roady(iroad):z=roadz(iroad)
dx=roaddx(iroad):tx=roadtx(iroad):dtx=dx/1000
dy=roaddy(iroad)
dz=roaddz(iroad)
gltranslatef(x,y,z)
x=0:y=0:z=0
glrotatef(roado1(iroad),0,0,1)
glbegin(gl_quads)
	glTexCoord2f(tx,0)
	glvertex3f(x,y-dy,z)
	gltexcoord2f(tx+dtx,0)
	glvertex3f(x+dx,y-dy,z+dz)
	glTexCoord2f(tx+dtx,1)
	glvertex3f(x+dx,y+dy,z+dz)
	gltexcoord2f(tx,1)
	glvertex3f(x,y+dy,z)
glend()	
End Sub
Sub drawparking(ByVal iroad As integer)
Dim As Single dx=1000,dy=400,tx=1,dz,x,y,z
Dim As Integer i,j
x=roadx(iroad):y=roady(iroad):z=roadz(iroad)
dx=roaddx(iroad):tx=roadtx(iroad):dtx=dx/1000
dy=roaddy(iroad)
dz=roaddz(iroad)
gltranslatef(x,y,z)
x=0:y=0:z=0
glrotatef(roado1(iroad),0,0,1)
glbegin(gl_quads)
	glTexCoord2f(tx,tx)
	glvertex3f(x,y-dy,z)
	gltexcoord2f(tx+dtx,tx)
	glvertex3f(x+dx,y-dy,z+dz)
	glTexCoord2f(tx+dtx,tx+dtx)
	glvertex3f(x+dx,y+dy,z+dz)
	gltexcoord2f(tx,tx+dtx)
	glvertex3f(x,y+dy,z)
glend()	
End Sub
Sub addroad(typeroad As Integer,x As Single,y As Single,z As Single,do1 As single)
Dim As Integer i,j,k,l,ii,jj,kk
Dim As Single dx,dy,dz,co1,si1
If kroad>=nroad Then Exit Sub
kroad+=1
i=kroad
Select Case typeroad
	Case 1
 roadtype(i)=1
 roadtexture(i)=roadtext
 dx=1000:dy=400
 roado1(i)=do1
 co1=Cos(do1*degtorad):si1=Sin(do1*degtorad)
 roadco1(i)=co1:roadsi1(i)=si1
 roaddx(i)=dx:roaddy(i)=dy
 roadx(i)=x:roady(i)=y:roadz(i)=z
 roadh=8'10'25
 dz=getterrainheight(x+dx*co1+dy*si1,y+dx*si1-dy*co1)
 roaddz(i)=max(dz,getterrainheight(x+dx*co1-dy*si1,y+dx*si1+dy*co1))+roadh-roadz(i)
 For k=0 To dx+1 Step dx/2
 	dz=roadz(i)+(k/dx)*roaddz(i)-roadh
   For l=-dy-scalex*2 To dy+scalex*2+1 Step scalex'50
     ii=(x+k*co1+l*si1)/scalex+256
     If ii>-100 And ii<612 Then
      jj=(y+k*si1-l*co1)/scalex+256
   	If jj>-100 And jj<612 Then
   		terrain(ii,jj)=dz/scalez
   		terrainroad(ii,jj)=1
     EndIf
     EndIf
   Next l
 Next k
 
	Case 2
 roadtype(i)=2
 roadtexture(i)=parktext
 dx=3000:dy=1200
 roado1(i)=do1
 co1=Cos(do1*degtorad):si1=Sin(do1*degtorad)
 roadco1(i)=co1:roadsi1(i)=si1
 roaddx(i)=dx:roaddy(i)=dy
 roadx(i)=x:roady(i)=y:roadz(i)=z
 roadh=8'10'25
 'dz=max(z-roadh,getterrainheight(x+dx*co1+dy*si1,y+dx*si1-dy*co1))
 roaddz(i)=0'max(dz,getterrainheight(x+dx*co1-dy*si1,y+dx*si1+dy*co1))+roadh-roadz(i)
 For k=0 To dx+1 Step dx/6
 	dz=z-roadh*dx/1000'roadz(i)+(k/dx)*roaddz(i)-roadh
   For l=-dy-scalex*2 To dy+scalex*2+1 Step scalex'50
     ii=(x+k*co1+l*si1)/scalex+256
     If ii>-100 And ii<612 Then
      jj=(y+k*si1-l*co1)/scalex+256
   	If jj>-100 And jj<612 Then
   		terrain(ii,jj)=dz/scalez
   		terrainroad(ii,jj)=1
     EndIf
     EndIf
   Next l
 Next k
End Select
End Sub
Function testroad(x As Single,y As Single) As Integer  
Dim As Integer i
For i=1 To nroad2
	If Abs(roadx(i)-x)<2000 Then
		If Abs(roady(i)-y)<2000 Then
			Return 1
		EndIf
	EndIf
Next
Return 0
End Function  
Function testroadh(x As Single,y As Single) As Single 
Dim As Integer i
Dim As Single xx,yy,dx,dy
For i=1 To nroad2
	If Abs(roadx(i)-x)<4000 Then
		If Abs(roady(i)-y)<4000 Then
			dy=-(x-roadx(i))*roadsi1(i)+(y-roady(i))*roadco1(i)
			If Abs(dy)<roaddy(i) Then
				dx=(x-roadx(i))*roadco1(i)+(y-roady(i))*roadsi1(i)
				If dx>0 And dx<roaddx(i) Then
					Return roadz(i)+(dx/roaddx(i))*roaddz(i)+1e-6 
				EndIf
			EndIf
		EndIf
	EndIf
Next
Return 0
End Function
Sub initroad()
Dim As Integer i,j,k,l,ii,jj,kk
Dim As Single x,y,z,dx,dy,dz,tx,dtx,ro1,do1
Randomize(imap)
kroad=0
ro1=-30
co1=Cos(ro1*degtorad):si1=Sin(ro1*degtorad)
i=kroad+1
roadtype(i)=2
dx=3000:dy=1200
x=0:y=0:z=0:roadh=8'25
z=getterrainheight(x,y)+roadh*dx/1000
tx=0:dtx=dx/1000
roadtx(i)=tx:roaddtx(i)=dtx
addroad(2,x,y,z,ro1)

ro1=-30
co1=Cos(ro1*degtorad):si1=Sin(ro1*degtorad)
i=kroad+1
roadtype(i)=1
'x=0:y=0:z=0
'dx=1000:z=getterrainheight(x,y)+roadh
x+=dx*co1:y+=dx*si1:z=roadz(i-1)+roaddz(i-1)
dx=1000:dy=400
tx+=dtx:dtx=dx/1000
roadtx(i)=tx:roaddtx(i)=dtx
addroad(1,x,y,z,ro1)

i=kroad+1
dx=1000
x+=dx*co1:y+=dx*si1:z=roadz(i-1)+roaddz(i-1)
tx+=dtx:dtx=dx/1000
roadtx(i)=tx:roaddtx(i)=dtx
addroad(1,x,y,z,ro1)

For j=1 To 5000
 i=kroad+1
 dx=1000*(1-Abs(Sin(do1*degtorad)))
 x+=dx*co1:y+=dx*si1:z=roadz(i-1)+roaddz(i-1)
 tx+=dtx:dtx=dx/1000
 roadtx(i)=tx:roaddtx(i)=dtx
 If Rnd<0.05 Then do1=(Rnd-0.4)*10
 Var dist=Sqr(x*x+y*y)
 If dist>256*scalex Then
 	 If (x*co1+y*si1)>=0 Then
 	 	If (x*si1-y*co1)>0 Then
 	 		do1=4
 	 	Else
 	 		do1=-4
 	 	EndIf
 	 EndIf
 EndIf
 ro1+=do1
 co1=Cos(ro1*degtorad):si1=Sin(ro1*degtorad)
 addroad(1,x,y,z,ro1)
Next 
i=kroad+1
roadtype(i)=2
x+=dx*co1:y+=dx*si1:z=roadz(i-1)+roaddz(i-1)
dx=3000:dy=1200
tx=0:dtx=dx/1000
roadtx(i)=tx:roaddtx(i)=dtx
addroad(2,x,y,z,ro1)
nroad2=i

For i=1 To nroad2-2
	x=roadx(i):y=roady(i)
	For j=i+2 To nroad2
		If Abs(x-roadx(j))<700 Then
			If Abs(y-roady(j))<700 Then
				roadtexture(i)=roadcrosstext
				roadtexture(j)=roadcrosstext
			EndIf
		EndIf
	Next
Next
For i=1 To nroad2 
  dx=roaddx(i):dy=roaddy(i)
  co1=roadco1(i):si1=roadsi1(i)
  x=roadx(i):y=roady(i):z=roadz(i)
  For k=0 To dx+1 Step dx/6
 	dz=z+(k/dx)*roaddz(i)-roadh
   For l=-dy-scalex*2 To dy+scalex*2+1 Step scalex'50
     ii=(x+k*co1+l*si1)/scalex+256
     If ii>-100 And ii<612 Then
      jj=(y+k*si1-l*co1)/scalex+256
   	If jj>-100 And jj<612 Then
   		terrain(ii,jj)=min(terrain(ii,jj),dz/scalez)
   		terrainroad(ii,jj)=1
      EndIf
     EndIf
   Next l
  Next k         
Next i
For i=2 To nroad2-1
  dx=roaddx(i):dy=roaddy(i)
  co1=roadco1(i):si1=roadsi1(i)
  x=roadx(i):y=roady(i):z=roadz(i)
  k=0:z=-999999
  For l=-dy-scalex*2 To dy+scalex*2+1 Step scalex'50
   ii=(x+k*co1+l*si1)/scalex+256
   If ii>-100 And ii<612 Then
      jj=(y+k*si1-l*co1)/scalex+256
   	If jj>-100 And jj<612 Then
   		if terrainroad(ii,jj) Then
      		z=max(z,terrain(ii,jj)*scalez+roadh)
   		endif 	
   	EndIf
   EndIf
  Next l 
  If z>-99999 Then
  	   roadz(i)=z
 		roaddz(i-1)=roadz(i)-roadz(i-1)
   	roaddz(i)=roadz(i+1)-roadz(i)
  EndIf
Next
End Sub 
Sub drawroads()
Dim As Integer i,j
glEnable GL_TEXTURE_2D 
For i=1 To nroad2
  If max(Abs(roadx(i)-mx),Abs(roady(i)-my))<20000 Then 	
	glpushmatrix
	myglbindtexture GL_TEXTURE_2D,roadtexture(i)
	'gltranslatef(roadx(i),roady(i),roadz(i))
	'glrotatef(roado1(i),0,0,1)
	Select Case roadtype(i)
		Case 1
			drawroad1(i)
		Case Else
			drawparking(i)
	End Select
	glpopmatrix
  EndIf 	
Next	
End Sub
Sub initterrain()
Dim As Integer i,j,k,l,n
Dim As Single x,y,xx,yy,h,hmin
If iedit=2 Then
 For i=-100 To 612
	For j=-100 To 612
		terrain(i,j)=0
	Next
 Next	

Else

Randomize(imap)
For i=-100 To 612
	For j=-100 To 612
		terrain0(i,j)=0
		terraincolor0(i,j).z=0.2'1
		terraincolor0(i,j).y=0.7'0.2
		terraincolor0(i,j).x=0.2
	Next
Next
h=10'40
For i=0 To 356'-100 To 612
	For j=0 To 356'-100 To 612
	   x=(terrain0(257-i,256-j)+terrain0(256-i,257-j))*0.5
		x+=(rnd-0.5)*h
	   y=(terrain0(257-i,256+j)+terrain0(256-i,255+j))*0.5
		y+=(rnd-0.5)*h
		terrain0(256-i,256-j)=x
		terrain0(256-i,256+j)=y
	Next
	For j=0 To 356'-100 To 612
	   x=(terrain0(255+i,256-j)+terrain0(256+i,257-j))*0.5
		x+=(rnd-0.5)*h
	   y=(terrain0(255+i,256+j)+terrain0(256+i,255+j))*0.5
		y+=(rnd-0.5)*h
		terrain0(256+i,256-j)=x
		terrain0(256+i,256+j)=y
	Next
Next
Var ismooth=1
For n=1 To ismooth
 For i=-99 To 611
	For j=-99 To 611
		terrainroad(i,j)=0
		terrain(i,j)=0
		For k=i-2 To i+2
			For l=j-2 To j+2
      		terrain(i,j)+=terrain0(k,l)			
			Next
		Next
		terrain(i,j)/=25
		hmin=min(hmin,terrain(i,j)+70)
	Next
 Next 
 For i=-99 To 611
	For j=-99 To 611
      terrain0(i,j)=terrain(i,j)
	Next
 Next 	
Next
   Dim As Integer ix,iy
   Dim As Single alt,hh,hh1,hh2,hh3
   For ix=0 To 512
   	For iy=0 To 512
           alt=(terrain(ix,iy)-hmin)*scalez
           hh=1.0:hh1=1.0:hh2=0:hh3=0
           If alt>1800 Then hh=min(1.5,1.0+(alt-1800)/400)
           If alt>2000 Then hh1=min(3.5,1.0+(alt-2000)/400)
           If alt>3000 Then hh2=0.7
           'h=terrain(ix,iy)+74
           'If h<7 Then hh3=min(0.32,(7-h)/24)
           terraincolor(ix,iy).x=min(1.0,terraincolor0(ix,iy).x*hh+hh2)
           terraincolor(ix,iy).y=min(1.0,terraincolor0(ix,iy).y*hh1+hh2+hh3)
           terraincolor(ix,iy).z=min(1.0,terraincolor0(ix,iy).z*hh1+hh2)
   	Next
   Next
Randomize

EndIf 

initroad()

caissez=getterrainheight(caissex,caissey)	
Var sc=330/680.0
housedx=680*sc:housedy=430*sc
doorx=housex-680*sc:doory=housey
doordx=90*sc:doordy=70*sc
housez=getterrainheight(housex,housey)	
For i=-1 To 1
	For j=-1 To 1
		housez=min(housez,getterrainheight(housex+i*housedx,housey+j*housedy))
	Next
Next
For i=1 To ntree2
	treez(i)=getterrainheight(treex(i),treey(i))
Next
End Sub
Sub drawterrain
Dim As Single x,y,x0,y0
Dim As Single i,j,i1,dx=27',dtx=-0.85,dty=-0.78
'texscale=(8000/scalex)/6.12
'texscale=2:dtx=-0.5-(0.1+mxx/scalex)/texscale:dty=-0.5-(0.1+myy/scalex)/texscale'kcos
dx=20'27'+min(57.0,Int((mz-mzsol0)*0.01*distscale))
'dx=Int(min(120.0,dx*max(1.0, distscale*3*narbre2/(narbre2+4*2*ntree2))))
dxterrain=dx
If tshadow=1 Then dx=3
x0=Int(mx/scalex+10000)-10000
y0=Int(my/scalex+10000)-10000

glbindtexture(gl_texture_2d,grasstexture0)
glcolor3f(0,0.7,0)
For x=max(-356.0,-dx+x0) To min(356.0-1,dx+x0)
	i=x+256+0.1
	while i<-100:i+=512+200:Wend 
	While i>612.2:i-=512+200:Wend 
   glBegin (GL_TRIANGLE_STRIP)	
	For y=max(-356.0,-dx+y0) To min(356.0,dx+y0)
     j=y+256+0.1
	  While j<-100:j+=512+200:Wend 
	  While j>612.2:j-=512+200:Wend
	  'If (Abs(x-x0)>1.1 Or Abs(y-(y0+1))>1.1 Or ishadow>=0)And tshadow=0 Then  
      'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
      glTexCoord2f(i/texscale,j/texscale)
 	   glvertex3f((x)*scalex,y*scalex,scalez*terrain(i,j))
 	   i1=i+1:If i1>612.2 Then i1-=512+200
      'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
      glTexCoord2f((i+1)/texscale,j/texscale)
 	   glvertex3f((x+1)*scalex,y*scalex,scalez*terrain(i1,j))
	  /'ElseIf tshadow=0 Then 
     'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
      glTexCoord2f(i/texscale+dtx,j/texscale+dty)
 	   glvertex3f((x)*scalex,y*scalex,scalez*terrain(i,j))
 	   i1=i+1:If i1>612.2 Then i1-=512+200
      'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
      glTexCoord2f((i+1)/texscale+dtx,j/texscale+dty)
 	   glvertex3f((x+1)*scalex,y*scalex,scalez*terrain(i1,j))
	  Else
     'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
      glTexCoord2f(i/texscale+dtx,j/texscale+dty)
 	   glvertex3f((x)*scalex,y*scalex,z)
 	   i1=i+1:If i1>612.2 Then i1-=512+200
      'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
      glTexCoord2f((i+1)/texscale+dtx,j/texscale+dty)
 	   glvertex3f((x+1)*scalex,y*scalex,z)
	  EndIf 
	  If Abs(x-x0)<1.1 And ishadow=1 And tshadow=0 Then
	  	If Abs(y-(y0-1))<0.1 Then
	  	  glend():glbindtexture(gl_texture_2d,grasstexture)
	  	  glcolor3f(1,1,1):glBegin (GL_TRIANGLE_STRIP)
        'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
        glTexCoord2f(i/texscale+dtx,j/texscale+dty)
 	     glvertex3f((x)*scalex,y*scalex,scalez*terrain(i,j))
 	     i1=i+1:If i1>612.2 Then i1-=512+200
        'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
        glTexCoord2f((i+1)/texscale+dtx,j/texscale+dty)
 	     glvertex3f((x+1)*scalex,y*scalex,scalez*terrain(i1,j))
 	   EndIf 
	  	If Abs(y-(y0+2))<0.1 Then
	  	  glend():glbindtexture(gl_texture_2d,grasstexture0)
	  	  glcolor3f(0,0.7,0):glBegin (GL_TRIANGLE_STRIP)
        'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
        glTexCoord2f(i/texscale,j/texscale)
 	     glvertex3f((x)*scalex,y*scalex,scalez*terrain(i,j))
 	     i1=i+1:If i1>612.2 Then i1-=512+200
        'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
        glTexCoord2f((i+1)/texscale,j/texscale)
 	     glvertex3f((x+1)*scalex,y*scalex,scalez*terrain(i1,j))
 	   EndIf 
	  EndIf '/  
	Next
	glend()
Next
End Sub
Sub drawshadow
Dim As Single x,y,x0,y0
Dim As integer i,j,i1,dx=27',dtx=-0.85,dty=-0.78
'texscale=(8000/scalex)/6.12
'texscale=2:dtx=-0.5-(0.1+mxx/scalex)/texscale:dty=-0.5-(0.1+myy/scalex)/texscale'kcos
glbindtexture(gl_texture_2d,grasstexture)
glenable gl_alpha_test
glAlphaFunc(gl_less,10/254)
glcolor3f(0,0.7,0)
glpushmatrix
For i=-bmpx To bmpx Step 50
	x=(mx+i*scalex/bmpx)
   glBegin (GL_TRIANGLE_STRIP)	
	For j=-bmpx To bmpx Step 50
		y=(my+j*scalex/bmpx)
     'glcolor3fv(Cast(glfloat Ptr,@terraincolor(i,j)))
      glTexCoord2f((i/bmpx+1)*0.5,(j/bmpx+1)*0.5)
 	   glvertex3f((x),y,getterrainheight2(x,y)+5)
      'glcolor3fv(cast(glfloat Ptr,@terraincolor(i1,j)))
      glTexCoord2f(((i+100)/bmpx+1)*0.5,(j/bmpx+1)*0.5)
 	   glvertex3f((x+100*scalex/bmpx),y,getterrainheight2(x+100*scalex/bmpx,y)+5)  
	Next
	glend()
Next
glpopmatrix
gldisable gl_alpha_test
End Sub
Function getterrainheight(ByVal x As Single,ByVal y As Single) As Single
Dim As Single h,dx,dy,z00,z10,z01,z11 
Dim As Integer i,j,i1,j1
	i=Int(x/scalex+100000)-100000
	dx=x/scalex-i
	j=Int(y/scalex+100000)-100000
	dy=y/scalex-j
	i+=256
	j+=256
	while i<-100:i+=512+200:Wend 
	While i>=612:i-=512+200:Wend 
	while j<-100:j+=512+200:Wend 
	While j>=612:j-=512+200:Wend
	i1=i+1
	j1=j+1
	While i1>=612:i1-=512+200:Wend
	While j1>=612:j1-=512+200:Wend 
z00=terrain(i,j)
z10=terrain(i1,j)
z01=terrain(i,j1)
z11=terrain(i1,j1)
If dx<=(1.0-dy) Then 
     h=( dx*(z10-z00) +dy*(z01-z00) +z00)
Else 
     h=( (1-dx)*(z01-z11) +(1-dy)*(z10-z11) +z11 )
EndIf 
Return h*scalez
End Function
Function getterrainheight2(ByVal x As Single,ByVal y As Single) As Single
Dim As Single h,dx,dy,z00,z10,z01,z11,dh=0 
Dim As Integer i,j,i1,j1
	i=Int(x/scalex+100000)-100000
	dx=x/scalex-i
	j=Int(y/scalex+100000)-100000
	dy=y/scalex-j
	i+=256
	j+=256
	while i<-100:i+=512+200:Wend 
	While i>=612:i-=512+200:Wend 
	while j<-100:j+=512+200:Wend 
	While j>=612:j-=512+200:Wend
	i1=i+1
	j1=j+1
	While i1>=612:i1-=512+200:Wend
	While j1>=612:j1-=512+200:Wend 
	
If terrainroad(i,j) Or terrainroad(i1,j) Or terrainroad(i,j1) _  
   Or terrainroad(i1,j1) Then dh=(roadh)	
z00=terrain(i,j)
z10=terrain(i1,j)
z01=terrain(i,j1)
z11=terrain(i1,j1)
If dx<=(1.0-dy) Then 
     h=( dx*(z10-z00) +dy*(z01-z00) +z00)
Else 
     h=( (1-dx)*(z01-z11) +(1-dy)*(z10-z11) +z11 )
EndIf 
Return h*scalez+dh
End Function
Function getterrainheight3(ByVal x As Single,ByVal y As Single) As Single
Var h=testroadh(x,y)
If Abs(h)>1e-7 Then testpiste=1:Return h
testpiste=0
Return getterrainheight2(x,y)	
End Function
Sub drawboussole
'gldrawtext "$",0,0
'gldrawtext "$",xmax/2,ymax/2
'gldrawtext "$",xmax,0
'gldrawtext "$",0,ymax
'gldrawtext "$",xmax,ymax
Dim As Single rx=12,dx=20,dy=20,scale=0.8,cosx,sinx
glpushmatrix
cosx=sin1:sinx=-cos1 
glcolor3f(1,1,1)
scale=0.8*520/ymax
gldrawtext "+", xmax-dx, ymax-dy,scale
gldrawtext "S", xmax-dx+cosx*rx, ymax-dy+sinx*rx,scale
gldrawtext "N", xmax-dx-cosx*rx, ymax-dy-sinx*rx,scale
gldrawtext "W", xmax-dx-sinx*rx, ymax-dy+cosx*rx,scale
gldrawtext "E", xmax-dx+sinx*rx, ymax-dy-cosx*rx,scale
glpopmatrix
End Sub
Sub drawradar
Dim As Integer i
Dim As Single dx=35,dy=100,rx=30*ymax/520
dx=10+rx:dy=65+rx
glpushmatrix
glplacecursor dx+5,dy-5
glTranslatef (0,0,-0.01)
glEnable GL_BLEND
glBlendFunc GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
gldisable gl_texture_2d
glcolor4f(0.3,1,0.3,0.7)
gldisk(0,2)
gldisable GL_BLEND 
'glcolor3f(0,0.5,0.5)
'gldrawtext "+",dx,dy,0.5
glcolor3f(0.9,1,1)
Var distmax=256*scalex
gldrawtext "+",dx+rx*max(-1.0,min(1.0,my/distmax)),dy+rx*max(-1.0,min(1.0,mx/distmax))
glpopmatrix
End Sub 
Sub drawvolant
 glenable gl_alpha_test
 glAlphaFunc(gl_less,1/254)
 glcolor3f(1,1,1)
 glbindtexture(gl_texture_2d,volanttext)
 glpushmatrix
 'glplacecursor(xmax*0.43,ymax*0.768,-30)
 glplacecursor(xmax*0.47,ymax*0.768,-30)
 If volantrot>volantmax Then volantrot=volantmax'120
 If volantrot<-volantmax Then volantrot=-volantmax
 glrotatef(volantrot,0,0,1)
 volantrot=0.75*volantrot+1e-10
 gltexcarre(4.5)
 glpopmatrix
 gldisable gl_alpha_test
End Sub
Sub subsavecustom()
Dim As String fic,resp,dir0
Dim As Integer ret,i,file
dir0=CurDir
ChDir("save\")  
fic=filedialog("save custom","*.custom")
ret=ChDir(dir0)
fic=Trim(fic)
If fic="" Then Exit Sub 
If InStr(fic,".")=0 Then fic+=".custom"
If LCase(Right(fic,7))<>".custom" Then notice "bad name "+fic:Exit Sub 
confirm("save in "+fic+" ?","save custom",resp)
If resp="yes" Then
   file=FreeFile
Open fic For Output As #file
Print #file,mykprop
Print #file,mykqueue
Print #file,mykroll
Print #file,mykpitch
Print #file,myrv
Print #file,myrqueue
Print #file,myrroll
Print #file,myrpitch
Print #file,mypoids
Print #file,myvcruise
Print #file,mykbrakes
Print #file,mykspeed
Print #file,mykpneu
Close #file
 	notice "custom saved as "+fic
EndIf
End Sub
Sub subloadcustom()
Dim As String fic,resp,dir0,ficin
Dim As Integer ret,i,file
dir0=CurDir
ChDir("save\")  
fic=filedialog("load custom","*.custom")
ret=ChDir(dir0)
fic=Trim(fic)
If fic="" Then Exit Sub 
If InStr(fic,".")=0 Then fic+=".custom"
If LCase(Right(fic,7))<>".custom" Then notice "bad name "+fic:Exit Sub 
confirm("load "+fic+" ?","load custom",resp)
If resp="yes" Then
   file=FreeFile
Open fic For Input As #file
mykprop=1
If Not Eof(file) Then Line Input #file,ficin:mykprop=Val(ficin)
mykqueue=1
If Not Eof(file) Then Line Input #file,ficin:mykqueue=Val(ficin)
mykroll=1
If Not Eof(file) Then Line Input #file,ficin:mykroll=Val(ficin)
mykpitch=1
If Not Eof(file) Then Line Input #file,ficin:mykpitch=Val(ficin)
myrv=1
If Not Eof(file) Then Line Input #file,ficin:myrv=Val(ficin)
myrqueue=1
If Not Eof(file) Then Line Input #file,ficin:myrqueue=Val(ficin)
myrroll=1
If Not Eof(file) Then Line Input #file,ficin:myrroll=Val(ficin)
myrpitch=1
If Not Eof(file) Then Line Input #file,ficin:myrpitch=Val(ficin)
mypoids=1
If Not Eof(file) Then Line Input #file,ficin:mypoids=Val(ficin)
myvcruise=1
If Not Eof(file) Then Line Input #file,ficin:myvcruise=Val(ficin)
mykbrakes=1
If Not Eof(file) Then Line Input #file,ficin:mykbrakes=Val(ficin)
myksuspension=1
If Not Eof(file) Then Line Input #file,ficin:myksuspension=Val(ficin)
mykspeed=1
If Not Eof(file) Then Line Input #file,ficin:mykspeed=Val(ficin)
mykpneu=1
If Not Eof(file) Then Line Input #file,ficin:mykpneu=Val(ficin)
Close #file
selectcomboindex("win3.kprop",Int(201.1-mykprop*100))
selectcomboindex("win3.kqueue",Int(201.1-mykqueue*100))
selectcomboindex("win3.kroll",Int(201.1-mykroll*100))
selectcomboindex("win3.kpitch",Int(201.1-mykpitch*100))
selectcomboindex("win3.poids",Int(201.1-mypoids*100))
selectcomboindex("win3.rv",Int(201.1-myrv*100))
selectcomboindex("win3.rqueue",Int(201.1-myrqueue*100))
selectcomboindex("win3.rroll",Int(201.1-myrroll*100))
selectcomboindex("win3.rpitch",Int(201.1-myrpitch*100))
selectcomboindex("win3.vcruise",Int(201.1-myvcruise*100))
selectcomboindex("win3.kbrakes",Int(201.1-mykbrakes*100))
selectcomboindex("win3.ksuspension",Int(201.1-myksuspension*100))
selectcomboindex("win3.kspeed",Int(201.1-mykspeed*100))
selectcomboindex("win3.kpneu",Int(201.1-mykpneu*100))
EndIf 
End Sub 
Sub subcustom2()
If custom=0 Then
	custom=1:setcheckbox("win3.custom")
Else
	custom=0:unsetcheckbox("win3.custom")
EndIf
End Sub
Dim Shared As String kvalue(150),kmaxfps(50)
Sub submaxfps()
Dim As Integer i
getcomboindex("win3.maxfps",i)
If i>0 Then maxfps=(61-i)	
End Sub
Sub subkprop()
Dim As Integer i
getcomboindex("win3.kprop",i)
If i>0 Then mykprop=(201-i)/100	
End Sub
Sub subkqueue()
Dim As Integer i
getcomboindex("win3.kqueue",i)
If i>0 Then mykqueue=(201-i)/100	
End Sub
Sub subkroll()
Dim As Integer i
getcomboindex("win3.kroll",i)
If i>0 Then mykroll=(201-i)/100	
End Sub
Sub subkpitch()
Dim As Integer i
getcomboindex("win3.kpitch",i)
If i>0 Then mykpitch=(201-i)/100	
End Sub
Sub subpoids()
Dim As Integer i
getcomboindex("win3.poids",i)
If i>0 Then mypoids=(201-i)/100	
End Sub
Sub subrv()
Dim As Integer i
getcomboindex("win3.rv",i)
If i>0 Then myrv=(201-i)/100	
End Sub
Sub subrqueue()
Dim As Integer i
getcomboindex("win3.rqueue",i)
If i>0 Then myrqueue=(201-i)/100	
End Sub
Sub subrroll()
Dim As Integer i
getcomboindex("win3.rroll",i)
If i>0 Then myrroll=(201-i)/100	
End Sub
Sub subrpitch()
Dim As Integer i
getcomboindex("win3.rpitch",i)
If i>0 Then myrpitch=(201-i)/100	
End Sub
Sub subvcruise()
Dim As Integer i
getcomboindex("win3.vcruise",i)
If i>0 Then myvcruise=(201-i)/100	
End Sub
Sub subkbrakes()
Dim As Integer i
getcomboindex("win3.kbrakes",i)
If i>0 Then mykbrakes=(201-i)/100	
End Sub
Sub subksuspension()
Dim As Integer i
getcomboindex("win3.ksuspension",i)
If i>0 Then myksuspension=(201-i)/100	
End Sub
Sub subkspeed()
Dim As Integer i
getcomboindex("win3.kspeed",i)
If i>0 Then mykspeed=(201-i)/100	
End Sub
Sub subkpneu()
Dim As Integer i
getcomboindex("win3.kpneu",i)
If i>0 Then mykpneu=(201-i)/100	
End Sub
Dim Shared As Integer windowcustom
Sub subcustom()
If windowcustom=1 Then quit=1:Exit Sub 
windowcustom=1
For i=0 To 150
	kvalue(i)=Str(200-i)
Next
For i=0 To 50
	kmaxfps(i)=Str(60-i)
Next
checkbox("win3.custom","custom vehicles    (values %)",@subcustom2,20,20,239,20)
statictext("win3.maxfps1", "maxfps",260,22,48,20)
combobox("win3.maxfps",@submaxfps,315,20,50,300)
statictext("win3.kprop1", "kprop",20,62,54,20)
combobox("win3.kprop",@subkprop,75,60,50,300)
statictext("win3.kqueue1","kqueue",20,92,54,20)
combobox("win3.kqueue",@subkqueue,75,90,50,300)
statictext("win3.kroll1", "kroll",20,122,54,20)
combobox("win3.kroll",@subkroll,75,120,50,300)
statictext("win3.kpitch1","kpitch",20,152,54,20)
combobox("win3.kpitch",@subkpitch,75,150,50,300)
statictext("win3.poids1","weight",20,182,54,20)
combobox("win3.poids",@subpoids,75,180,50,300)
statictext("win3.rv1", "rspeed",220,62,54,20)
combobox("win3.rv",@subrv,275,60,50,300)
statictext("win3.rqueue1", "rqueue",220,92,54,20)
combobox("win3.rqueue",@subrqueue,275,90,50,300)
statictext("win3.rroll1", "rroll",220,122,54,20)
combobox("win3.rroll",@subrroll,275,120,50,300)
statictext("win3.rpitch1","rpitch",220,152,54,20)
combobox("win3.rpitch",@subrpitch,275,150,50,300)
statictext("win3.vcruise1","vcruise",220,182,54,20)
combobox("win3.vcruise",@subvcruise,275,180,50,300)
statictext("win3.kbrakes1","brakes",20,212,54,20)
combobox("win3.kbrakes",@subkbrakes,75,210,50,300)
statictext("win3.kpneu1","pneus",20,242,54,20)
combobox("win3.kpneu",@subkpneu,75,240,50,300)
statictext("win3.ksuspension1","suspension",197,212,77,20)
combobox("win3.ksuspension",@subksuspension,275,210,50,300)
statictext("win3.kspeed1","kspeed",220,242,54,20)
combobox("win3.kspeed",@subkspeed,275,240,50,300)
button("win3.quit","quit",@subquit,20,280,60,30)
button("win3.save","save",@subsavecustom,90,280,60,30)
button("win3.load","load",@subloadcustom,160,280,60,30)
openwindow("win3","custom",xmax*0.3,ymax*0.3,400,350)
trapclose("win3",@subquit)
If custom=1 Then setcheckbox("win3.custom")
reloadcombo("win3.maxfps",kmaxfps())
selectcomboindex("win3.maxfps",Int(61.1-maxfps))
reloadcombo("win3.kprop",kvalue())
selectcomboindex("win3.kprop",Int(201.1-mykprop*100))
reloadcombo("win3.kqueue",kvalue())
selectcomboindex("win3.kqueue",Int(201.1-mykqueue*100))
reloadcombo("win3.kroll",kvalue())
selectcomboindex("win3.kroll",Int(201.1-mykroll*100))
reloadcombo("win3.kpitch",kvalue())
selectcomboindex("win3.kpitch",Int(201.1-mykpitch*100))
reloadcombo("win3.poids",kvalue())
selectcomboindex("win3.poids",Int(201.1-mypoids*100))
reloadcombo("win3.rv",kvalue())
selectcomboindex("win3.rv",Int(201.1-myrv*100))
reloadcombo("win3.rqueue",kvalue())
selectcomboindex("win3.rqueue",Int(201.1-myrqueue*100))
reloadcombo("win3.rroll",kvalue())
selectcomboindex("win3.rroll",Int(201.1-myrroll*100))
reloadcombo("win3.rpitch",kvalue())
selectcomboindex("win3.rpitch",Int(201.1-myrpitch*100))
reloadcombo("win3.vcruise",kvalue())
selectcomboindex("win3.vcruise",Int(201.1-myvcruise*100))
reloadcombo("win3.kbrakes",kvalue())
selectcomboindex("win3.kbrakes",Int(201.1-mykbrakes*100))
reloadcombo("win3.ksuspension",kvalue())
selectcomboindex("win3.ksuspension",Int(201.1-myksuspension*100))
reloadcombo("win3.kspeed",kvalue())
selectcomboindex("win3.kspeed",Int(201.1-mykspeed*100))
reloadcombo("win3.kpneu",kvalue())
selectcomboindex("win3.kpneu",Int(201.1-mykpneu*100))
While quit=0 And guitestkey(vk_escape)=0
	guiscan
	Sleep 100
Wend
guiclosewindow("win3")
initavion()
Sleep 300
guiscan
quit=0
windowcustom=0
End Sub
Function testcollide(wdx As Single,wdy As Single,wdz As Single) As Integer 
Dim As Integer i,j

If Abs(wdx-mx)<2200 And Abs(wdy-my)<2200 Then 
	If isinside(wdx,wdy,doorx,doory,doordx,doordy)=0 Then
 	   If isinside(wdx,wdy,housex,housey,housedx+40,housedy+40)=1 Then
		  If isinside(wdx,wdy,housex,housey,housedx-40,housedy-40)=0 Then
				Return 1			
		  EndIf		
   	EndIf
	EndIf
EndIf 

For i=1 To ntree2
	If Abs(treex(i)-wdx)<30 Then
		If Abs(treey(i)-wdy)<30 Then
			If Abs(treez(i)-wdz)<240 Then
				Return 1
			EndIf
		EndIf
	EndIf
Next

Return 0
End Function 
